Foxit PDF SDK

Public Member Functions | List of all members
FSDK.Redact Class Reference
Inheritance diagram for FSDK.Redact:

## Public Member Functions
| Apply ()
| Apply current redact annotation: remove the text, graphics and annotations under annotation rectangle permanently. More...
| constructor ()
| Constructor.
| constructor (annot)
| Constructor, with parent class object. More...
| EnableAutoFontSize ()
| Enable auto font size for the overlay text. More...
| EnableRepeatOverlayText (is_to_repeat_overlay_text)
| Set the flag to decide whether to repeat the overlay text. More...
| GetApplyFillColor ()
| Get the filling color which is used for rollover appearance and will be used after redaction is applied. More...
| GetDefaultAppearance ()
| Get default appearance data. More...
| GetFillColor ()
| Get fill color. More...
| GetOverlayText ()
| Get the overlay text. More...
| GetOverlayTextAlignment ()
| Get alignment value of overlay text. More...
| GetQuadPoints ()
| Get quadrilaterals. More...
| IsOverlayTextRepeated ()
| Check whether the overlay text is repeated or not. More...
| SetApplyFillColor (fill_color)
| Set the filling color which is used for rollover appearance and will be used after redaction is applied. More...
| SetDefaultAppearance (default_ap)
| Set default appearance data. More...
| SetFillColor (fill_color)
| Set fill color. More...
| SetOverlayText (overlay_text)
| Set the overlay text. More...
| SetOverlayTextAlignment (alignment)
| Set alignment value of overlay text. More...
| SetQuadPoints (quad_points_array)
| Set quadrilaterals. More...
Public Member Functions inherited from FSDK.Markup
| AddReply ()
| Add a new reply to the end of reply list. More...
| AddRichText (content, style)
| Add a new rich text string to the end. More...
| AddStateAnnot (title, model, state)
| Add a new state annotation. More...
| constructor ()
| Constructor.
| constructor (annot)
| Constructor, with parent class object. More...
| GetBorderOpacity ()
| Get the border opacity of the annotation. More...
| GetCreationDateTime ()
| Get creation date time. More...
| GetFillOpacity ()
| Get the fill opacity of the annotation. More...
| GetGroupElements ()
| Get an element (as markup annotation) from the group that current markup annotation belongs to. More...
| GetGroupHeader ()
| Get the header annotation (as primary annotation) of the group that current markup annotation belongs to. More...
| GetIntent ()
| Get intent name. More...
| GetOpacity ()
| Get opacity value. More...
| GetPopup ()
| Get related pop-up annotation. More...
| GetReply (index)
| Get a reply by index. More...
| GetReplyCount ()
| Count all replies. More...
| GetRichTextContent (index)
| Get text string of a rich text string specified by index. More...
| GetRichTextCount ()
| Get the count of rich text strings. More...
| GetRichTextStyle (index)
| Get style data of a rich text string specified by index. More...
| GetStateAnnots (model)
| Get all state annotations in a specified state model. More...
| GetSubject ()
| Get subject string. More...
| GetTitle ()
| Get title string. More...
| InsertRichText (index, content, style)
| Insert a new rich text string to the place which is specified by index. More...
| IsGrouped ()
| Check whether current markup annotation is in a group or not. More...
| RemoveAllReplies ()
| Remove all the replies. More...
| RemoveAllStateAnnots ()
| Remove all the state annotations. More...
| RemovePopup ()
| Remove related pop-up annotation. More...
| RemoveReply (index)
| Remove a reply by index. More...
| RemoveRichText (index)
| Remove a rich text string specified by index. More...
| SetBorderOpacity (opacity)
| Set the border opacity of the annotation. More...
| SetCreationDateTime (date_time)
| Set creation date time. More...
| SetFillOpacity (opacity)
| Set the fill opacity of the annotation. More...
| SetIntent (intent)
| Set intent name. More...
| SetOpacity (opacity)
| Set opacity value. More...
| SetPopup (popup)
| Set related pop-up annotation. More...
| SetRichTextContent (index, content)
| Set text string of a rich text string specified by index. More...
| SetRichTextStyle (index, style)
| Set style data of a rich text string specified by index. More...
| SetSubject (subject)
| Set subject string. More...
| SetTitle (title)
| Set title string. More...
| Ungroup ()
| Ungroup current markup annotation from the group it belongs to. More...
Public Member Functions inherited from FSDK.Annot
| constructor ()
| Constructor.
| constructor (page, annot_dict)
| Constructor, with PDF page and annotation's PDF dictionary. More...
| GetAppearanceStream (type, appearance_state)
| Get annotation's appearance stream with specified type and state. More...
| GetBorderColor ()
| Get border color. More...
| GetBorderInfo ()
| Get border information. More...
| GetContent ()
| Get content. More...
| GetDeviceRect (matrix)
| Get annotation rectangle in device coordinate system. More...
| GetDict ()
| Get annotation's dictionary object. More...
| GetDisplayMatrix (page_display_matrix)
| Get the display matrix, from PDF coordinate system to targeted device coordinate system. More...
| GetFlags ()
| Get annotation flags. More...
| GetIndex ()
| Get the index of current annotation in the page which current annotation belongs to. More...
| GetModifiedDateTime ()
| Get last modified date time. More...
| GetOptionalContent ()
| Get the PDF dictionary of annotation's optional content. More...
| GetPage ()
| Get the related PDF page. More...
| GetRect ()
| Get rectangle, in PDF coordinate system. More...
| GetType ()
| Get actual annotation type of current annotation. More...
| GetUniqueID ()
| Get unique ID. More...
| HasProperty (property)
| Whether current annotation has the specified annotation's property. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| IsMarkup ()
| Check if current annotation is a markup annotation. More...
| Move (rect)
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
| Move (rect, is_reset_appearance)
| Move current annotation to a new position, specified by a new rectangle in PDF coordinate system. More...
| RemoveProperty (property)
| Remove a specified annotation's property. More...
| ResetAppearanceStream ()
| Reset appearance stream. More...
| ResetAppearanceStream (is_generate_new_appearance_obj)
| Reset appearance stream. More...
| SetBorderColor (color)
| Set border color. More...
| SetBorderInfo (border)
| Set border information. More...
| SetContent (content)
| Set content. More...
| SetFlags (flags)
| Set annotation flags. More...
| SetModifiedDateTime (date_time)
| Set last modified date time. More...
| SetUniqueID (unique_id)
| Set unique ID. More...

## Additional Inherited Members
Static Public Attributes inherited from FSDK.Markup
static | e_EndingStyleButt
| A short line at the endpoint perpendicular to the line itself.
static | e_EndingStyleCircle
| A circle filled with the annotation's interior color if any.
static | e_EndingStyleClosedArrow
| Two short lines meeting in an acute angle as in the OpenArrow style and connected by a third line to form a triangular closed arrowhead filled with the annotation's interior color if any.
static | e_EndingStyleDiamond
| A diamond shape filled with the annotation's interior color if any.
static | e_EndingStyleNone
| Enumeration for line ending style. More...
static | e_EndingStyleOpenArrow
| Two short lines meeting in an acute angle to form an open arrowhead.
static | e_EndingStyleRClosedArrow
| A triangular closed arrowhead in the reverse direction from ClosedArrow.
static | e_EndingStyleROpenArrow
| Two short lines in the reverse direction from OpenArrow.
static | e_EndingStyleSlash
| A short line at the endpoint approximately 30 degrees clockwise from perpendicular to the line itself.
static | e_EndingStyleSquare
| A square filled with the annotation's interior color if any.
static | e_MeasureTypeA
| Measurement of area.
static | e_MeasureTypeD
| Measurement of distance in any direction.
static | e_MeasureTypeS
| Measurement of the slope of a line.
static | e_MeasureTypeT
| Measurement of angles.
static | e_MeasureTypeX
| Enumeration for annotation's measure type. More...
static | e_MeasureTypeY
| Measurement of change along the y axis.
static | e_StateAccepted
| (Used with state model FSDK.Markup.e_StateModelReview) The user agrees with the change.
static | e_StateCancelled
| (Used with state model FSDK.Markup.e_StateModelReview) The change has been cancelled.
static | e_StateCompleted
| (Used with state model FSDK.Markup.e_StateModelReview) The change has been completed.
static | e_StateDeferred
| (Used with state model FSDK.Markup.e_StateModelReview) The change has been deferred.
static | e_StateFuture
| (Used with state model FSDK.Markup.e_StateModelReview) The change will be working in the future.
static | e_StateMarked
| (Used with state model FSDK.Markup.e_StateModelMarked) The annotation has been marked by the user.
static | e_StateModelMarked
| Enumeration for markup annotation's state model. More...
static | e_StateModelReview
| Markup annotation state model: review.
static | e_StateNone
| Enumeration for markup annotation's state. More...
static | e_StateRejected
| (Used with state model FSDK.Markup.e_StateModelReview) The user disagrees with the change.
static | e_StateUnmarked
| (Used with state model FSDK.Markup.e_StateModelMarked) The annotation has not been marked by the user.
Static Public Attributes inherited from FSDK.Annot
static | e_3D
| Annotation type: 3D annotation. One of standard annotation in <PDF reference 1.7>.
static | e_AppearanceTypeDown
| Annotation's down appearance.
static | e_AppearanceTypeNormal
| Enumeration for the type of annotation's appearance. More...
static | e_AppearanceTypeRollover
| Annotation's rollover appearance.
static | e_Caret
| Annotation type: caret annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Circle
| Annotation type: circle annotation. One of standard annotation in <PDF reference 1.7>.
static | e_FileAttachment
| Annotation type: file attachment annotation. One of standard annotation in <PDF reference 1.7>.
static | e_FlagHidden
| Annotation flag: hidden. More...
static | e_FlagInvisible
| Enumeration for PDF annotation flags. More...
static | e_FlagLocked
| Annotation flag: locked. More...
static | e_FlagLockedContents
| Annotation flag: locked contents. More...
static | e_FlagNoRotate
| Annotation flag: no rotate. More...
static | e_FlagNoView
| Annotation flag: no view. More...
static | e_FlagNoZoom
| Annotation flag: no zoom. More...
static | e_FlagPrint
| Annotation flag: print. More...
static | e_FlagReadOnly
| Annotation flag: read only. More...
static | e_FlagToggleNoView
| Annotation flag: toggle no view. More...
static | e_FreeText
| Annotation type: free text annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Highlight
| Annotation type: highlight annotation. One of standard annotation in <PDF reference 1.7>.
static | e_HighlightingInvert
| Highlighting mode: Invert, which is to invert the contents of the annotation rectangle.
static | e_HighlightingNone
| Enumeration for PDF annotation highlighting mode. More...
static | e_HighlightingOutline
| Highlighting mode: Outline, which is to invert the annotation's border.
static | e_HighlightingPush
| Highlighting mode: Push, which is to display the annotation's down appearance, if any.
static | e_HighlightingToggle
| Highlighting mode: Toggle. This is only useful for widget annotation.
static | e_Ink
| Annotation type: ink annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Line
| Annotation type: line annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Link
| Annotation type: link annotation. One of standard annotation in <PDF reference 1.7>.
static | e_MKEntryBackgroundColor
| Background color entry. "BG" in MK dictionary.
static | e_MKEntryBorderColor
| Border color entry. "BC" in MK dictionary.
static | e_MKEntryDownCaption
| Down caption (or alternate caption) entry. "AC" in MK dictionary. More...
static | e_MKEntryDownIcon
| Down icon (or alternate icon) entry. "IX" in MK dictionary. More...
static | e_MKEntryIconCaptionRelation
| Icon and caption relation entry. "TP" in MK dictionary. More...
static | e_MKEntryIconFit
| Icon fit information entry. "IF" in MK dictionary. More...
static | e_MKEntryNormalCaption
| Normal caption entry. "CA" in MK dictionary. More...
static | e_MKEntryNormalIcon
| Normal icon entry. "I" in MK dictionary. More...
static | e_MKEntryRolloverCaption
| Rollover caption entry. "RC" in MK dictionary. More...
static | e_MKEntryRolloverIcon
| Rollover icon entry. "RI" in MK dictionary. More...
static | e_MKEntryRotation
| Enumeration for annotation's MK dictionary (an appearance characteristics) entry. More...
static | e_MKRelationCaptionAboveIcon
| Caption above the icon.
static | e_MKRelationCaptionBelowIcon
| Caption below the icon.
static | e_MKRelationCaptionLeft
| Caption to the left of the icon.
static | e_MKRelationCaptionOvrlayOnIcon
| Caption overlaid directly on the icon.
static | e_MKRelationCaptionRight
| Caption to the right of the icon.
static | e_MKRelationNoCaption
| No caption; icon only.
static | e_MKRelationNoIcon
| Enumeration for icon and caption relative position in annotation's MK dictionary. More...
static | e_Movie
| Annotation type: movie annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Note
| Annotation type: note annotation, which is just "Text" annotation - one of standard annotation in <PDF reference 1.7>.
static | e_PagingSeal
| Annotation type: paging seal annotation. A Foxit PDF SDK custom annotation type (not a standard annotation type).
static | e_Polygon
| Annotation type: polygon annotation. One of standard annotation in <PDF reference 1.7>.
static | e_PolyLine
| Annotation type: polyline annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Popup
| Annotation type: pop-up annotation. One of standard annotation in <PDF reference 1.7>.
static | e_PrinterMark
| Annotation type: printer's mark annotation. One of standard annotation in <PDF reference 1.7>.
static | e_PropertyBorderColor
| Annotation property: border color. More...
static | e_PropertyCreationDate
| Annotation property: creation date. More...
static | e_PropertyFillColor
| Annotation property: fill color. More...
static | e_PropertyModifiedDate
| Enumeration for some PDF annotation property. More...
static | e_PSInk
| Annotation type: pressure sensitive ink annotation.
static | e_Redact
| Annotation type: redact annotation.
static | e_RichMedia
| Annotation type: rich media annotation.
static | e_Screen
| Annotation type: screen annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Sound
| Annotation type: sound annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Square
| Annotation type: square annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Squiggly
| Annotation type: squiggly annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Stamp
| Annotation type: stamp annotation. One of standard annotation in <PDF reference 1.7>.
static | e_StrikeOut
| Annotation type: strikeout annotation. One of standard annotation in <PDF reference 1.7>.
static | e_TrapNet
| Annotation type: trap network annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Underline
| Annotation type: underline annotation. One of standard annotation in <PDF reference 1.7>.
static | e_UnknownType
| Enumeration for PDF annotation type. More...
static | e_Watermark
| Annotation type: watermark annotation. One of standard annotation in <PDF reference 1.7>.
static | e_Widget
| Annotation type: widget annotation. One of standard annotation in <PDF reference 1.7>. More...

## Detailed Description

Class FSDK.Redact represents a Foxit custom annotation type (not a standard annotation type). This kind of annotation is used to mark some content of a PDF page and these content will be removed once the redact annotations are applied. An existed redact annotation can be retrieved from PDF page by functions FSDK.PDFPage.GetAnnot and FSDK.PDFPage.GetAnnotAtPoint. A new redact annotation would be returned by function FSDK.Redaction.MarkRedactAnnot, instead of FSDK.PDFPage.AddAnnot.
Class FSDK.Redact is derived from class FSDK.Markup and also offers functions to get/set markup annotation's basic properties of a redact annotation. Currently, FSDK.Annot.SetBorderInfo can be used for a redact annotation, but will not have any effect on the appearance of redact annotation. Besides, redact annotation cannot be moved by function FSDK.Annot.Move.

See also
  FSDK.Redaction
  FSDK.PDFPage
  FSDK.Markup

## Member Function Documentation

## ◆ Apply()

FSDK.Redact.Apply | ( |  | ) |

Apply current redact annotation: remove the text, graphics and annotations under annotation rectangle permanently.

Once this functions is called successfully, all page content(text object, image object, and path object) and annotations within area of current redact annotation rectangle will be removed permanently. However, if other redaction annotations intersect with or are contained within the current redaction, they will not be deleted. For current redact annotation, it also will be removed (with its pop-up annotation if any) as well - that means current annotation object will be useless when this function succeeds. Area of current redact annotation rectangle will be filled by the color specified by function FSDK.Redact.SetApplyFillColor.

Returns
  true means success, while false means failure.

## ◆ constructor()

FSDK.Redact.constructor | ( | annot |  | ) |

Constructor, with parent class object.

Parameters

  [in] | annot | Parent class object.

## ◆ EnableAutoFontSize()

FSDK.Redact.EnableAutoFontSize | ( |  | ) |

Enable auto font size for the overlay text.

Returns
  None.

## ◆ EnableRepeatOverlayText()

FSDK.Redact.EnableRepeatOverlayText | ( | is_to_repeat_overlay_text |  | ) |

Set the flag to decide whether to repeat the overlay text.

Parameters

  [in] | is_to_repeat_overlay_text | true means to repeat the overlay text, while false means not. Default value: false.

Returns
  None.

## ◆ GetApplyFillColor()

FSDK.Redact.GetApplyFillColor | ( |  | ) |

Get the filling color which is used for rollover appearance and will be used after redaction is applied.

Returns
  The fill color. Format: 0xRRGGBB. If no fill color can be found, 0xFFFFFF will be returned.

## ◆ GetDefaultAppearance()

FSDK.Redact.GetDefaultAppearance | ( |  | ) |

Get default appearance data.

This property has effect on redact annotation's appearance. Default appearance data can be used in formatting text.

Returns
  The default appearance data.

## ◆ GetFillColor()

FSDK.Redact.GetFillColor | ( |  | ) |

Get fill color.

Returns
  The fill color. Format: 0xRRGGBB. If no fill color can be found, 0x000000 will be returned.

## ◆ GetOverlayText()

FSDK.Redact.GetOverlayText | ( |  | ) |

Get the overlay text.

Returns
  The overlay text string.

## ◆ GetOverlayTextAlignment()

FSDK.Redact.GetOverlayTextAlignment | ( |  | ) |

Get alignment value of overlay text.

This property has effect on the overlay text of redact annotation's appearance.

Returns
  The alignment value. Please refer to values starting from FSDK.e_AlignmentLeft and this would be one of these values.

## ◆ GetQuadPoints()

FSDK.Redact.GetQuadPoints | ( |  | ) |

Get quadrilaterals.

The order of points in a quadrilateral should be:

- The first point is the point in left-top corner of the quadrilateral.
- The second point is the point in right-top corner of the quadrilateral.
- The third point is the point in left-bottom corner of the quadrilateral.
- The fourth point is the point in right-bottom corner of the quadrilateral.

Returns
  A quadrilateral points array that receives the quadrilaterals value.

## ◆ IsOverlayTextRepeated()

FSDK.Redact.IsOverlayTextRepeated | ( |  | ) |

Check whether the overlay text is repeated or not.

Returns
  true means that the overlay text is repeated, while false means not.

## ◆ SetApplyFillColor()

FSDK.Redact.SetApplyFillColor | ( | fill_color |  | ) |

Set the filling color which is used for rollover appearance and will be used after redaction is applied.

Parameters

  [in] | fill_color | New fill color to be set. Format: 0xRRGGBB.

Returns
  None.

## ◆ SetDefaultAppearance()

FSDK.Redact.SetDefaultAppearance | ( | default_ap |  | ) |

Set default appearance data.

This property has effect on redact annotation's appearance. Default appearance data can be used in formatting text.
If user wants the new default appearance data has effect on annotation's appearance, please call function FSDK.Annot.ResetAppearanceStream after setting new default appearance data.

Parameters

  [in] | default_ap | The new default appearance data to be set. flags of input data can be used to decide which information is/are to be updated with the new data; for those no updated data, they will keep to use old data.

Returns
  true means success, while false means failure. Specially, this function will return false if the parameter default_ap contains any incorrect value, for example:
  - flags of input data includes the FSDK.DefaultAppearance.e_FlagFont but font of input data is invalid.
  - flags of input data includes the FSDK.DefaultAppearance.e_FlagFontSize but text size of input data is not bigger than zero.

## ◆ SetFillColor()

FSDK.Redact.SetFillColor | ( | fill_color |  | ) |

Set fill color.

Parameters

  [in] | fill_color | New fill color to be set. Format: 0xRRGGBB.

Returns
  None.

## ◆ SetOverlayText()

FSDK.Redact.SetOverlayText | ( | overlay_text |  | ) |

Set the overlay text.

Parameters

  [in] | overlay_text | The overlay text string to be set.

Returns
  None.

## ◆ SetOverlayTextAlignment()

FSDK.Redact.SetOverlayTextAlignment | ( | alignment |  | ) |

Set alignment value of overlay text.

This property has effect on the overlay text of redact annotation's appearance. If user wants the new alignment has effect on the overlay text of annotation's appearance, please call function FSDK.Annot.ResetAppearanceStream after setting new alignment.

Parameters

  [in] | alignment | The new alignment value. Please refer to values starting from FSDK.e_AlignmentLeft and this should be one of these values.

Returns
  None.

## ◆ SetQuadPoints()

FSDK.Redact.SetQuadPoints | ( | quad_points_array |  | ) |

Set quadrilaterals.

This property has effect on the redact annotation's appearance.The order of points in a quadrilateral should be :

- The first point is the point in left-top corner of the quadrilateral.
- The second point is the point in right-top corner of the quadrilateral.
- The third point is the point in left-bottom corner of the quadrilateral.
- The fourth point is the point in right-bottom corner of the quadrilateral.

If user wants the new quadrilaterals has effect on annotation's appearance, please call function FSDK.Annot.ResetAppearanceStream after setting quadrilaterals.

Parameters

  [in] | quad_points_array | A valid array of quadrilaterals. It should not be an empty array.

Returns
  None.